import torch

D = 10 
d = 2 
A = torch.randn(D, d, D, dtype=torch.float64)
T = torch.randn(d, d, d, d, dtype=torch.float64)

def Hopt(x):
    Tx = (T.view(-1, d) @ x.view(D, d, D).permute(1, 0, 2).contiguous().view(d,-1)).view(d,d,d,D,D).permute(1,3,0,2,4).contiguous()
    return ((A.view(D, d*D)@Tx.view(d*D, d*d*D)).view(D*d, d*D) @ A.permute(1,2,0).contiguous().view(d*D, D)).view(D**2*d)

B = torch.einsum('ldr,adcb,icj->lairbj', (A, T, A)).contiguous().view(D**2*d, D**2*d)

x = torch.randn(D**2*d, dtype=torch.float64)

y = torch.mv(B, x)
z = Hopt(x)

print (  (y-z).abs().sum()  )
